public class Fachada {

  private static Fachada instancia;
  private CadastroContas contas;
  private CadastroClientes clientes;

  protected Fachada() {
	  initCadastros();
  }

  private void initCadastros() {
	ArrayContas rep = new ArrayContas();
	contas = new CadastroContas(rep);
	ListaClientes repClientes = new ListaClientes();
	clientes = new CadastroClientes(repClientes);
  }


  public static Fachada obterInstancia() {
	 if (instancia == null) {
	   instancia = new Fachada();
	 }
	 return instancia;
  }

  //metodos par amanipular clientes
  public void atualizarCliente(Cliente c){
	  clientes.atualizar(c);
  }
  public Cliente procurarCliente(String cpf){
	return clientes.procurar(cpf);
  }
  public void inserirCliente(Cliente c){
	clientes.inserir(c);
  }
  public void removerCliente(String cpf){
	  clientes.remover(cpf);
  }

  //metodos para manipular contas
  public void atualizarConta(Conta c){
	contas.atualizar(c);
  }
  public Conta procurarConta(String n){
	  return contas.procurar(n);
  }
  public void inserirConta(Conta c){
    Cliente cli = c.getCliente();
    if(cli != null){
      clientes.procurar(cli.getCpf());
      contas.inserir(c);
    }else {
      throw new IllegalArgumentException("cliente nulo");
    }
 }
  public void removerConta(String n){
	  contas.remover(n);
  }
  public void creditar(String n, double v){
    contas.creditar(n, v);
  }
  public void debitar(String n, double v){
    contas.debitar(n, v);
  }
  public void transferir(String origem, String destino, double val){
	  contas.transferir(origem, destino, val);
  }
  public ColecaoContasIteravel procurarContas(String cpfCliente){
    return contas.procurarContas(cpfCliente);
  }
}
